version: 2
jobs:
  build:
    machine:
      image: ubuntu-1604:201903-01
    working_directory: ~/workspace
    steps:
      - run:
          name: checkout code
          command: |
            git clone  https://${GITHUB_TOKEN}@github.com/guaychou/mkpl-final-project.git .
            git fetch --tags
            git fetch --all
      - run:
          name: Exporting Release version variable
          command: |
            echo 'export RELEASE_VERSION="3.0.2"' >> $BASH_ENV  
      - run:
          name: build docker image mkpl-project
          command: |
           if [ "$CIRCLE_BRANCH" == "master" ]; then
             cd application && docker build -t lordchou/mkpl-project:`echo $RELEASE_VERSION` .
             docker build -t lordchou/mkpl-project:latest .
           else
             git checkout $CIRCLE_BRANCH && echo "checkout to $CIRCLE_BRANCH"
             cd application && docker build -t lordchou/mkpl-project:`echo $RELEASE_VERSION-rc` .
           fi
      - run: 
          name: build docker image mkpl-database
          command: |
           if [ "$CIRCLE_BRANCH" == "master" ]; then
             cd mysql && docker build -t lordchou/mkpl-database:`echo $RELEASE_VERSION` .
             docker build -t lordchou/mkpl-database:latest .
           else
             git checkout $CIRCLE_BRANCH && echo "checkout to $CIRCLE_BRANCH"
             cd mysql && docker build -t lordchou/mkpl-database:`echo $RELEASE_VERSION-rc` .
           fi
      - run:
          name: List docker images
          command: docker images
      
      - run: 
          name: docker push to dockerhub
          command: |
           echo `echo $DOCKER_PASSWORD | base64 -d` | docker login -u $DOCKER_USERNAME --password-stdin
           if [ "$CIRCLE_BRANCH" == "master" ]; then
             docker push lordchou/mkpl-database:`echo $RELEASE_VERSION`
             docker push lordchou/mkpl-project:`echo $RELEASE_VERSION`
             docker push lordchou/mkpl-project:latest
             docker push lordchou/mkpl-database:latest
             sed -i -e "s/latest/$RELEASE_VERSION/g" docker-compose.yml
           else
             docker push lordchou/mkpl-database:`echo $RELEASE_VERSION-rc`
             docker push lordchou/mkpl-project:`echo $RELEASE_VERSION-rc`
           fi
    
      - run:
          name: Release to github
          command: |
            if [ "$CIRCLE_BRANCH" == "master" ]; then
              git add . 
              git config credential.helper 'cache --timeout=120'
              git config --global user.name "$GITHUB_USERNAME"
              git config --global user.email "$GITHUB_EMAIL"
              git commit -m "updating version code to $RELEASE_VERSION"
              git tag $RELEASE_VERSION -a -m "Creating tag version `echo $RELEASE_VERSION` from circleci"
              git push -q https://${GITHUB_TOKEN}@github.com/guaychou/mkpl-final-project.git $RELEASE_VERSION
            else
              echo "Not Pushing Back to Origin Branch `echo $CIRCLE_BRANCH` not master"
            fi
workflows:
  version: 2
  build:
    jobs:
      - build